#!/bin/lua

function computer(a, b)
	local file = io.open("input")
	local tape = {}

	for opcode in string.gmatch(file:read("*line"), "%d+") do
		table.insert(tape, tonumber(opcode))
	end

	-- restore 1202 program state
	tape[2], tape[3] = a, b

	local position = 1
	repeat
		local args = {tape[position + 1], tape[position + 2], tape[position + 3]}
		local opcode = tape[position]

		if opcode == 1 then
			tape[args[3] + 1] = tape[args[1] + 1] + tape[args[2] + 1]
		elseif opcode == 2 then
			tape[args[3] + 1] = tape[args[1] + 1] * tape[args[2] + 1]
		elseif opcode == 99 then
			return tape[1]
		end

		position = position + 4
	until false
end

for noun = 0, 99 do
	for verb = 0, 99 do
		local result = computer(noun, verb)
		if result == 19690720 then
			print(100 * noun + verb)
			os.exit()
		end
	end
end
